<template>
  <nav :class="{'drawer-container': true, light: light, show: show}">
    <nuxt-link to="/login" :class="{link: true, dark: light}" v-ripple v-if="!isLoggedIn" @click.native="onLinkClick">ورود</nuxt-link>
    <nuxt-link to="/register" :class="{link: true, dark: light}" v-ripple v-if="!isLoggedIn" @click.native="onLinkClick">ثبت نام</nuxt-link>
    <nuxt-link to="/dashboard" :class="{link: true, dark: light}" v-ripple v-if="isLoggedIn" @click.native="onLinkClick">داشبورد</nuxt-link>
    <nuxt-link to="/dashboard/edit" :class="{link: true, dark: light}" v-ripple v-if="isLoggedIn" @click.native="onLinkClick">ویرایش حساب کاربری</nuxt-link>
    <nuxt-link to="/dashboard/addresses" :class="{link: true, dark: light}" v-ripple v-if="isLoggedIn" @click.native="onLinkClick">آدرس های من</nuxt-link>
    <nuxt-link to="/dashboard/orders" :class="{link: true, dark: light}" v-ripple v-if="isLoggedIn" @click.native="onLinkClick">سفارش های من</nuxt-link>
    <div :class="{divider: true, dark: light}"></div>
    <nuxt-link v-for="(link, i) in links" :key="i" :to="link.route" :class="{link: true, dark: light}" v-ripple @click.native="onLinkClick">{{link.title}}</nuxt-link>
    <div :class="{divider: true, dark: light}" v-if="isLoggedIn"></div>
    <nuxt-link to="/dashboard/admin/categories" :class="{link: true, dark: light}" v-ripple v-if="isAdmin" @click.native="onLinkClick">مدیریت دسته بندی ها</nuxt-link>
    <nuxt-link to="/dashboard/admin/products" :class="{link: true, dark: light}" v-ripple v-if="isAdmin" @click.native="onLinkClick">مدیریت محصولات</nuxt-link>
    <nuxt-link to="/dashboard/admin/users" :class="{link: true, dark: light}" v-ripple v-if="isAdmin" @click.native="onLinkClick">مدیریت کاربران</nuxt-link>
    <nuxt-link to="/dashboard/admin/orders" :class="{link: true, dark: light}" v-ripple v-if="isAdmin" @click.native="onLinkClick">مدیریت سفارشات</nuxt-link>
    <nuxt-link to="/dashboard/admin/blog" :class="{link: true, dark: light}" v-ripple v-if="isAdmin" @click.native="onLinkClick">مدیریت بلاگ</nuxt-link>
    <div :class="{divider: true, dark: light}" v-if="isAdmin"></div>
    <button :class="{link: true, logout: true, dark: light}" v-ripple v-if="isLoggedIn" @click="logout">خروج</button>
  </nav>
</template>

<script>
export default {
  name: "TheNavigationDrawer",
  props: {
    isLoggedIn: {
      type: Boolean,
      required: true
    },
    light: {
      type: Boolean,
      default: false
    },
    show: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    links() {
      return this.$store.getters['settings/getNavigationLinks'];
    },
    isAdmin() {
      return this.$store.getters['auth/isAdmin'];
    }
  },
  methods: {
    onLinkClick(route) {
      this.$emit('routeClicked');
    },
    logout() {
      this.$store.dispatch("auth/logout").then(response => {
        this.$store.dispatch('notifications/push', {
          message: 'با موفقیت خارج شدید!',
          type: 'success',
          light: true,
          timeout: 2000
        });
      });
      this.$emit('routeClicked');   
    }
  }
}
</script>


<style lang="stylus" scoped>
@import '~assets/styles/variables'

.drawer-container
  background-color $black
  position absolute
  display flex
  flex-direction column
  top $header-height
  padding-top $header-drawer-padding-top
  padding-bottom $header-drawer-padding-bottom
  left 100%
  width 100%
  height 'calc(100vh - %s)' % $header-height
  z-index 1
  overflow-y scroll
  visibility hidden
  transition all .2s ease-in
  &::-webkit-scrollbar 
    width 0
    background transparent
  &.light
    background-color $light
  &.show
    left 0
    visibility visible

.link
  width 100%
  padding $header-drawer-link-padding
  @media only screen and (max-width: 600px) 
    padding: $header-drawer-link-padding--md
  &:hover
    background-color rgba($white, .05)
  &.dark
    &:hover
      background-color rgba($black, .05)

.logout
  background-color transparent
  outline none
  border none
  font-size inherit 
  font-family inherit
  color inherit
  text-align right
  &:hover
    cursor pointer

.divider
  min-height 1px
  margin 1.5rem 0;
  background-color rgba($white, .2)
  &.dark
    background-color rgba($black, .2)
</style>
